
/*@ begin PerfTuning ( 
 def build {
   arg command = 'icc';
   arg options = '-fast';
 }

 def performance_params {
   param UI[] = [1,2,4,8];
 }

 def input_params {
   param N[] = [1000];
 }

 def input_vars {

# case 1: both declarations and initializations are generated by the driver
   decl double static x[N] = random;
   decl double static y[N] = 0;

# case 2: declarations are generated by the driver, and initializations are provided by the user
#   decl double static x[N];
#   decl double static y[N];
#   arg init_file = 'ptune2_init_code.c';

# case 3: both declarations and initializations are provided by the user
#   arg decl_file = 'ptune2_decl_code.h';
#   arg init_file = 'ptune2_init_code.c';
 }

# def performance_test_code {
#   arg skeleton_code_file = 'ptune2_skeleton_code.c'; 
# }

) @*/

int i, it;
double alpha = 10.0;

/*@ begin Loop (
transform RegTile(loops=['i'], ufactors=[UI])
 for (i=0; i<=N-1; i++)
   y[i] = y[i] + alpha*x[i];
) @*/

for (i=0; i<=N-1; i++)
  y[i] = y[i] + alpha*x[i];

/*@ end @*/
/*@ end @*/


